-- Shotgun push on all weapons
-- Author: rogerxiii / DvD
 
local push_scale 		= 2.0	-- Value between 0.0 - 10.0, sets the force of the push, 1.0 is normal shotgun push
local push_direction 	= 1.0   -- Value between 0.0 - 1.0, sets the height direction of the push, 1.0 is all the way up, 0.0 is all the way down
 
-----------------------------------------------------------------------------------------------------------------------------------------------
 
local dmgmul = 0
local old_collect = RaycastWeaponBase._collect_hits
function RaycastWeaponBase:_collect_hits(from, to)
	local unique_hits, hit_enemy = old_collect(self, from, to)
	
	if hit_enemy and unique_hits[1] then
		local p_unit = managers.player:player_unit()
		local dam = self:get_damage_falloff(self:_get_current_damage(dmgmul), unique_hits[1], p_unit)
		local hit_result = self._bullet_class:on_collision(unique_hits[1], self._unit, p_unit, dam)
		if hit_result and hit_result.type == "death" then
			local unit = unique_hits[1].unit
			if unit:movement()._active_actions[1] and unit:movement()._active_actions[1]:type() == "hurt" then
				unit:movement()._active_actions[1]:force_ragdoll() end
			
			for i = 0, unit:num_bodies() - 1 do
				local u_body = unit:body(i)
				
				if u_body:enabled() and u_body:dynamic() then
					World:play_physic_effect(Idstring("physic_effects/shotgun_hit"), u_body, 
					Vector3(unique_hits[1].ray.x, unique_hits[1].ray.y, unique_hits[1].ray.z + push_direction) * 600 * push_scale, 4 * u_body:mass(), 
					(unique_hits[1].ray:cross(math.UP) + math.UP * 0.5) * -1000 * math.sign(mvector3.distance(unique_hits[1].hit_position, unit:position()) - 100), 2)
				end
			end
		end
	end
	
	return unique_hits, hit_enemy
end
 
local old_fire = RaycastWeaponBase._fire_raycast
function RaycastWeaponBase:_fire_raycast(user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul)
	dmgmul = dmg_mul
	return old_fire(self, user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul)
end